|##########|
|#MAGIC   #|HAHDPCDL
|#PROJECT #|"AVLTreeTest"
|#PATHS   #|"StdProject"
|#FLAGS   #|xx---x--xxx---x-----------------
|#USERSW  #|--------------------------------
|#USERMASK#|--------------------------------
|#SWITCHES#|xx---xxxxx-xx---
|##########|
MODULE AVLTreeTest;

FROM Strings   IMPORT Compare;
FROM System    IMPORT Equation;
FROM InOut     IMPORT WriteGrp;
FROM Resources IMPORT New;
IMPORT AVLTrees;

TYPE
  PersonPtr = POINTER TO Person;

DEFINITION MODULE PersonTrees = AVLTrees.AVLTrees(PersonPtr);

TYPE
  Person = RECORD OF PersonTrees.AVLNode;
             name    : STRING(20);
             alter   : SHORTINT;
             strasse : STRING(30);
           END;

PROCEDURE ComparePerson(a,b : PersonPtr):Equation;
BEGIN
  RETURN Compare(a^.name,b^.name);
END ComparePerson;


VAR
  PersonTree : PersonTrees.AVLTree;
  p,p2       : PersonPtr;

BEGIN
  TRACK
    PersonTree.Init(ComparePerson);
    New(p);
    p^.name:="Meier";
    p^.alter:=38;
    p^.strasse:="Neuer Weg 27";
    PersonTree.Insert(p);
    New(p);
    p^.name:="Mller";
    p^.alter:=75;
    p^.strasse:="Musterweg 80";
    PersonTree.Insert(p);
    New(p);
    p^.name:="Schulze";
    p^.alter:=21;
    p^.strasse:="Kaiserstr. 17";
    PersonTree.Insert(p);

    New(p);
    p^.name:="Mller";
    p2:=PersonTree.Search(p);
    WriteString(p2^.name);WriteLn;
    WriteInt(p2^.alter);WriteLn;
    WriteString(p2^.strasse);WriteLn;
  END;
END AVLTreeTest.
