|##########|
|#MAGIC   #|HAHEANHJ
|#PROJECT #|"DosExAllTest"
|#PATHS   #|"StdProject"
|#FLAGS   #|xx---x--x-x-x-x-----------------
|#USERSW  #|--------------------------------
|#USERMASK#|--------------------------------
|#SWITCHES#|x----xxxxx-xx---
|##########|
MODULE DosExAllTest;
IMPORT Dos;
FROM Resources  IMPORT New,MemReqs,Allocate;
FROM T_Exec     IMPORT PortGrp,MsgGrp;
IMPORT Exec;
FROM Strings    IMPORT SysStr,Str;
IMPORT T_Dos;
IMPORT InOut AS io;

VAR
  Output      : Dos.FileHandlePtr;
  Entry       : Dos.ExAllDataPtr;
  Control     : Dos.ExAllControlPtr;
  Buffer      : ANYPTR;
  BufSize     : LONGINT;
  i           : LONGINT;
  ExLock      : Dos.FileLockPtr;
  HelpDate    : Dos.DateTime;
  c           : CHAR;

BEGIN
  Output:=Dos.Open("CON:",Dos.newFile);
  HelpDate.format:=Dos.CDN;
  Allocate(HelpDate.strDay,16);
  Allocate(HelpDate.strDate,16);
  Allocate(HelpDate.strTime,16);
  BufSize:=100;
  Allocate(Buffer,BufSize,clear:=TRUE);
  ExLock:=Dos.Lock("sys:",Dos.sharedLock);
  ASSERT(ExLock#NIL,T_Dos.ObjectNotFound);
  Control:=Dos.AllocDosObjectList(Dos.exAllControl,NIL);
  ASSERT(Control#NIL,Resources.NotEnoughMemory);
  Control.lastkey:=0;
  Control.matchString:=NIL;
  Control.matchFunc:=NIL;
  WHILE Dos.ExAll(ExLock,Buffer,BufSize,Dos.date,Control) DO
    Entry:=Buffer;
    FOR i:=1 TO Control.entries DO
      Dos.DatePtr(HelpDate'PTR)^:=Entry.date;
      IF NOT Dos.DateToStr(HelpDate) THEN
        io.WriteString("Error");
      END;
      Dos.FPuts(Output,Entry.name);Dos.FPuts(Output,HelpDate.strDate);Dos.FPuts(Output,&10);
      Entry:=Entry.next;
    END;
  END;
  Entry:=Buffer;
  FOR i:=1 TO Control.entries DO
    Dos.DatePtr(HelpDate'PTR)^:=Entry.date;
    FORGET Dos.DateToStr(HelpDate);
    Dos.FPuts(Output,Entry.name);Dos.FPuts(Output,HelpDate.strDate);Dos.FPuts(Output,&10);
    Entry:=Entry.next;
  END;
  FORGET Dos.Read(Output,c'PTR,1);
  FORGET Dos.Close(Output);
  Dos.Unlock(ExLock);
  Dos.FreeDosObject(Dos.exAllControl,Control);
END DosExAllTest.
