|##########|
|#MAGIC   #|BNDLOLJH
|#PROJECT #|"Farn"
|#PATHS   #|"StdProject"
|#FLAGS   #|xx---x--x---x-x-----------------
|#USERSW  #|--------------------------------
|#USERMASK#|--------------------------------
|#SWITCHES#|x----x----------
|##########|
MODULE Farn;

FROM GfxScreen  IMPORT Screen,OpenScreen,CloseScreen;
FROM GfxDraw    IMPORT ClearScreen,WritePixel,ReadPixel,SetAPen;
FROM InOut      IMPORT WriteString,WriteLn,ReadString,WriteReal,Write,WriteInt;
FROM Resources  IMPORT New;

TYPE
  VReal   = ARRAY [0..1] OF FFP;
  VInt    = ARRAY [0..1] OF INTEGER;

  Base    = RECORD
              mul : ARRAY [0..1] OF VReal;
              add : VReal;
            END;

CONST
  pi180   = 3.141592654/180.;
  zoom    = 0.1*512.;
  wa      =   0.00*pi180;
  wb      =  -2.50*pi180;
  wc      =  49.00*pi180;
  wd      = 120.00*pi180;
  we      = -50.00*pi180;

VAR
  Bases   := ARRAY OF Base:((mul=(( 0.00*COS(wa), 0.00*SIN(wa)),
                                 ( 0.00 (* -0.16*SIN(wa) *), 0.16*COS(wa))),add=(0.00,0.00)),
                           (mul=(( 0.85*COS(wb), 0.85*SIN(wb)),
                                 (-0.85*SIN(wb), 0.85*COS(wb))),add=(0.00,1.60)),
                           (mul=(( 0.30*COS(wc), 0.30*SIN(wc)),
                                 (-0.30*SIN(wc), 0.30*COS(wc))),add=(0.00,1.60)),
                           (mul=(( 0.30*COS(wd), 0.30*SIN(wd)),
                                 (-0.37*SIN(we), 0.37*COS(we))),add=(0.00,0.44)));

CONST
  Mitte   = VInt:(200,005);

VAR
  VArray  : ARRAY [0..1] OF
              RECORD
                len  : INTEGER;
                data : POINTER TO ARRAY [0..20000] OF VInt;
              END;
  source,
  dest    : INTEGER;

  screen  : Screen;

PROCEDURE BMul(VAR base : Base;vec : VReal):VReal;
BEGIN
  (* $W- *)
  WITH base DO
    RESULT[0]:=base.mul[0,0]*vec[0]+base.mul[1,0]*vec[1]+base.add[0];
    RESULT[1]:=base.mul[0,1]*vec[0]+base.mul[1,1]*vec[1]+base.add[1];
  END;
END BMul;

PROCEDURE DrawPoint(vec : VReal);
VAR v : VInt;
BEGIN
  v[0]:=INTEGER(vec[0]*zoom)+Mitte[0];
  v[1]:=INTEGER(vec[1]*zoom)+Mitte[1];

  IF (v[0] OF 0..639) AND (v[1] OF 0..511) THEN
    IF ReadPixel(screen,v[0],v[1])=0 THEN
      (* $W- *)
      WITH VArray[dest] AS var DO
        var.data[var.len]:=v;
        INC(var.len);
        IF var.len=20000 THEN HALT(0) END;
      END;
      WritePixel(screen,v[0],v[1]);
    END;
  END;
END DrawPoint;

PROCEDURE RedrawPicture;
VAR rVec : VReal;
    i,j  : INTEGER;
BEGIN
  ClearScreen(screen);
  dest:=1-source;
  VArray[dest].len:=0;
  WITH VArray[source] AS var DO
    FOR i:=var.len-1 TO 0 BY -1 DO
      rVec[0]:=FFP(var.data[i,0]-Mitte[0])/zoom;
      rVec[1]:=FFP(var.data[i,1]-Mitte[1])/zoom;

      FOR j:=0 TO 3 DO
        DrawPoint(BMul(Bases[j],rVec));
      END;
    END;
  END;
  source:=1-source;
END RedrawPicture;

VAR hs : STRING(5);
    i  : INTEGER;

BEGIN
  WriteReal(FFP(-0.16*SIN(wa)),10,5);Write("_");

  WriteReal(Bases[0].mul[0,0],10,5);Write(" ");
  WriteReal(Bases[0].mul[0,1],10,5);Write(" ");
  WriteReal(Bases[0].mul[1,0],10,5);Write(" ");
  WriteReal(Bases[0].mul[1,1],10,5);Write(" ");

  New(VArray[0].data);New(VArray[1].data);
  source:=0;
  VArray[0].len:=1;
  VArray[0].data[0]:=VInt:(160,128);
  OpenScreen(screen,1,TRUE,TRUE);
  SetAPen(screen,1);
  FOR i:=1 TO 10 DO
    RedrawPicture;
  END;
CLOSE
END Farn.


