|##########|
|#MAGIC   #|BNDLOMCM
|#PROJECT #|"Feigenbaum"
|#PATHS   #|"StdProject"
|#FLAGS   #|xx---x--x-----x-----------------
|#USERSW  #|--------------------------------
|#USERMASK#|--------------------------------
|#SWITCHES#|x----x----------
|##########|
MODULE Feigenbaum;

(* $V- $R- $S- $N- *)

FROM GfxScreen IMPORT Screen,OpenScreen,Palette,SetPalette;
FROM GfxDraw   IMPORT SetAPen,Line,Draw,WritePixel;

VAR s : Screen;

TYPE REAL=LONGREAL;

PROCEDURE CalcFix(r : REAL):REAL;
VAR x : REAL;
BEGIN
  (* $W- *)
  WITH INTEGER AS i DO
    x:=0.5;
    FOR i:=1 TO 200 DO
      x:=r*x*(1.-x);
    END;
    RETURN x;
  END;
END CalcFix;

PROCEDURE DrawFix(r : REAL;xx : INTEGER);
VAR i : INTEGER;
    x : REAL;
BEGIN
  x:=CalcFix(r);
  FOR i:=1 TO 400 DO
    x:=r*x*(1.-x);
    WritePixel(s,xx,INTEGER(x*256));
  END;
END DrawFix;

VAR i : INTEGER;

BEGIN
  OpenScreen(s,1,FALSE,FALSE);
  FOR i:=0 TO 319 DO
    DrawFix(REAL(i)*(1.4/320.)+2.6,i);
  END;
END Feigenbaum.

