|##########|
|#MAGIC   #|HAHDPDCJ
|#PROJECT #|"Prism"
|#PATHS   #|"StdProject"
|#FLAGS   #|xx---x--xx--x-x-----------------
|#USERSW  #|--------------------------------
|#USERMASK#|--------------------------------
|#SWITCHES#|xx---xxx-x------
|##########|
MODULE Prism;

|Neue Demo mit PAL, NTSC, HZ70 Option und Rcksetzen des Songs. Auerdem
|kein Abschalten des ConstCheck mehr ntig.
|Datum: 05.07.1992

|******************************************************************************
|Dies ist ein Beispiel, wie man mithilfe des Cluster-Soundmoduls auf recht
|einfache Weise seine eigenen Musikstcke kreiert. Ich wnsche allen Cluster-
|maniacs und denen, die es werden wollen, viel Spa!         S. Herr, 28.09.92
|******************************************************************************

|Ein Tip: Lade das Sound.def in einen weiteren Textpuffer. Dann kannst Du stets
|die Definitionen der einzelnen Datenstrukturen betrachten und mit den in diesem
|Beispiel auftretenden Ausprgungen vergleichen.

|Hier werden die Funktionen importiert, die wir zum Einladen und Abspielen des
|Liedes bentigen.
FROM Sound IMPORT LoadInstrument,KillInstrument,Instrument,Instruments,
                  Noteval,Effects,Pattern,Patterns,Song,SongPointer,
                  StartSong,StopSong,GoFirstPos,InitSoundSystem,
                  ArrT,TS,TR,VideoModes;

|Ntige Textein-/ausgaberoutinen
FROM InOut IMPORT WriteLn,WriteString,WriteInt,Read;

|Stringfunktionen
FROM Strings IMPORT Concat;

TYPE
  String = STRING(100);

|Lege den Pfad fest, aus dem wir spter die Samples einladen werden.
CONST
  PfadName = "Cluster:Samples/";

|In diesem Array sind die Namen der Samples aufgefhrt, die sich in obigem
|Directory befinden.
CONST
  SampleNamen = ARRAY OF String:
       ("spacebells",
        "spacebass",
        "breaksnareclap",
        "emxhit2",
        "rtype1",
        "rtype2",
        "backblast",
        "chinasbest",
        "hihatclose.4",
        "tom3",
        "440thick-bk");

  SampleAnzahl = SampleNamen'RANGE; |Stelle die Anzahl der Samples in obigem
                                    |Array fest.


|In dieses Array werden die Instrumente eingetragen. Nach dem Einladen der
|Samples von Disk/Platte steht hier drin ein Zeiger auf den Sampledaten-
|speicher (der im Chip-Memory liegt), sowie die Lnge des jeweiligen Samples.
|Danach folgt der Loop-Offset und die Loop-Lnge, d.h. wenn das Sample
|das erste Mal abgespielt wurde, kann es ab einer bestimmten Offset-Position
|erneut von der DMA abgespielt werden, bis nach einer gewissen (Loop-)Lnge
|das Ende erreicht und die Schleife (Loop) erneut gespielt wird.
|Der letzte Wert in einer Zeile dieses Arrays ist die Default-Lautstrke des
|Samples.
VAR
  MyInstruments := Instruments : (
                     (NIL, 0, 0, 2, 18),
                     (NIL, 0, 0, 2, 43),
                     (NIL, 0, 0, 2, 64),
                     (NIL, 0, 0, 2, 62),
                     (NIL, 0, 0, 2, 54),
                     (NIL, 0, 0, 15658, 33), |<- gelooptes Sample!
                     (NIL, 0, 0, 2, 62),
                     (NIL, 0, 0, 2, 50),
                     (NIL, 0, 0, 2, 35),
                     (NIL, 0, 0, 2, 32),
                     (NIL, 0, 0, 2, 62));



|Ab hier werden nun die grundlegenden Elemente eines Liedes definiert: Die
|Patterns. Ein Pattern ist eine abgeschlossene Ansammlung von Noten. Mehrere
|Patterns werden spter mittels einer Arrangementtablle zu dem endgltigen Lied
|zusammengestellt.
|Es werden also in einem Pattern sich fters im Lied wiederholende Notenmuster
|(daher auch das Wort "pattern": englisch "Muster") zusammengefat.
|Die Definition geschieht als CONST-Deklaration:

CONST

  Pause64 = Pattern:(     |Dies ist ein Pattern mit zwei Noten:

    (Val=PS,Dur=64,Ins=0,Eff=HF,EVl=0), |(Bem.: Val= usw. kann weggelassen
                                        |werden!)

                          |Notenwert PS bedeutet Pause; 64 ist die Anzahl
                          |der Zeiteinheiten, die die Pause dauert.
                          |Die erste 0 ist die Instrumentenummer (siehe oben).
                          |HF ist ein Effekt, er bedeutet "High Frequency",
                          |und schaltet den Tiefpafilter des Amiga ab
                          |(Funktioniert nicht mit allen Amigas). Die zweite
                          |0 ist der Effektwert, der hier 0 ist.

    (PE, 0, 0, NE, 0));   |Die zweite Note beendet schon das Pattern:
                          |PE bedeutet "Pattern End". Evt. eingetragene
                          |Effekte und Instrument werden von der Abspiel-
                          |routine ignoriert. (Hier "NE": No Effect).
                          |Diese "Pseudonote" wird nicht wirklich abgespielt!


  Bassline1 = Pattern:(   |Dieses Pattern definiert eine Basslinie.
    (c3,12, 1, NE, 0),    |Man sieht, wie die Notenwerte eingetragen werden:
    (c3, 2, 1, NE, 0),    |kleiner Buchstabe entspricht der Note ohne
    (A2, 2, 1, NE, 0),    |Vorzeichen, die nachfolgende Zahl gibt die Oktave
    (c3, 6, 1, NE, 0),    |an: c3 bedeutet also "c" in der dritten Oktave.
    (c3, 6, 1, NE, 0),    |Ein groer Buchstabe bedeutet also ein Vorzeichen:
    (A2, 4, 1, NE, 0),    |G2 bedeutet also "gis" in der zweiten Oktave.
    (G2, 6, 1, NE, 0),
    (G2, 2, 1, NE, 0),
    (G2, 4, 1, NE, 0),    |Die 1 in der Mitte bedeutet "Instrument #1"
    (G2, 4, 1, NE, 0),
    (g2, 6, 1, NE, 0),
    (g2, 2, 1, NE, 0),    |Zu den Notendauern ist folgendes zu bemerken:
    (g2, 4, 1, NE, 0),    |Eine Notendauer entspricht dem Vielfachen von
    (A2, 4, 1, NE, 0),    |in der (Soundmodul-internen) Variable SPEED.
    (PE, 0, 0, NE, 0));   |Diese Variable ist durch ein Effektkommando
                          |beeinflubar, wie im nchsten Pattern ersichtlich:

  TomBreak = Pattern:(
    (PS,52, 9, SP, 4),    |<- hier wird SPEED mit "SP, 4" auf 4 Rasterstrahl-
    (e3, 2, 9, NE, 0),    |durchlufe der Amiga-Videoerzeugung eingestellt.
    (e3, 2, 9, NE, 0),    |ACHTUNG: Es sind keine Werte kleiner als 2 fr die
    (d3, 2, 9, NE, 0),    |SPEED-Variable erlaubt!
    (d3, 2, 9, NE, 0),
    (c3, 1, 9, NE, 0),    |Ob also die Auflsung (d.h. die krzeste spielbare
    (c3, 1, 9, NE, 0),    |Notendauer) bei 1/8, 1/16, 1/32 etc. betrgt, hngt
    (c3, 1, 9, NE, 0),    |also direkt vom Wert der Variablen SPEED und von der
    (c3, 1, 9, NE, 0),    |jeweiligen Notendauer ab.
    (PE, 0, 0, NE, 0));

                          |Noch eine Bemerkung: Die Abspielrate ist noch von
                          |der Bildwiederholfrequenz des Amigas abhngig.
                          |Je nachdem, ob man einen PAL-, NTSC- oder 70Hz-
                          |Screen offen hat, mu die Variable SPEED angeglichen
                          |werden. Dies wird beim Aufruf der StartSong-Routine
                          |erledigt. Nheres siehe unten im Programm.

  BasicDrums = Pattern:(
    (e3, 4,10, NE, 0),
    (f3, 1, 8, NE, 0),
    (f3, 1, 8, NE, 0),    |An diesem Pattern erkennt man, da innerhalb
    (f3, 1, 8, NE, 0),    |eines Patterns verschiedene Instrumente ge-
    (f3, 1, 8, NE, 0),    |spielt werden knnen. Man beachte aber, da
    (a2, 4, 2, NE, 0),    |ein Pattern nur auf EINEM Kanal ausgegeben werden
    (e3, 2,10, NE, 0),    |kann, d.h. verschiedene Instrumente knnen innheralb
    (a2, 2, 2, NE, 0),    |eines Patterns nicht auf verschiedene DMA-Kanle
    (e3, 4,10, NE, 0),    |verteilt werden.
    (f3, 2, 8, NE, 0),
    (f3, 2, 8, NE, 0),
    (a2, 4, 2, NE, 0),
    (a2, 2, 2, NE, 0),
    (a2, 2, 2, NE, 0),
    (e3, 4,10, NE, 0),
    (f3, 1, 8, NE, 0),
    (f3, 1, 8, NE, 0),
    (f3, 1, 8, NE, 0),
    (f3, 1, 8, NE, 0),
    (a2, 4, 2, NE, 0),
    (e3, 2,10, NE, 0),
    (a2, 2, 2, NE, 0),
    (e3, 4,10, NE, 0),
    (f3, 2, 8, NE, 0),
    (f3, 2, 8, NE, 0),
    (a2, 2, 2, NE, 0),
    (a2, 4, 2, NE, 0),
    (a2, 2, 2, NE, 0),
    (PE, 0, 0, NE, 0));

  BellAcc = Pattern:(
    (c2,32, 4, NE, 0),
    (G2,16, 4, NE, 0),
    (g2,16, 4, NE, 0),
    (PE, 0, 0, NE, 0));

  Gong = Pattern:(
    (c2,64, 7, NE, 0),
    (PE, 0, 0, NE, 0));

  Melody1 = Pattern:(
    (F2,12, 0, NE, 0),
    (f2,12, 0, NE, 0),
    (C2, 8, 0, NE, 0),
    (D2,32, 0, NE, 0),

    (F2,12, 0, NE, 0),
    (G2,12, 0, NE, 0),
    (A2, 8, 0, NE, 0),
    (D3,32, 0, NE, 0),

    (F2,12, 0, NE, 0),
    (f2,12, 0, NE, 0),
    (C2, 8, 0, NE, 0),
    (D2,32, 0, NE, 0),

    (F2,12, 0, NE, 0),
    (G2,12, 0, NE, 0),
    (A2, 8, 0, NE, 0),
    (D3,16, 0, NE, 0),

    (F3, 6, 0, NE, 0),
    (f3, 6, 0, NE, 0),
    (C3, 4, 0, NE, 0),
    (D3,64, 0, NE, 0),
    (PE, 0, 0, NE, 0));

  BlastAndGong = Pattern:(
    (PS, 4, 0, NE, 0),
    (c1,12, 6, NE, 0),
    (c2,36, 7, NE, 0),
    (e3, 2, 9, NE, 0),
    (e3, 2, 9, NE, 0),
    (d3, 2, 9, NE, 0),
    (d3, 2, 9, NE, 0),
    (c3, 1, 9, NE, 0),
    (c3, 1, 9, NE, 0),
    (c3, 1, 9, NE, 0),
    (c3, 1, 9, NE, 0),
    (PE, 0, 0, NE, 0));

  DieterBohlen = Pattern:(
    (e2,12, 3, NE, 0),
    (e2, 2, 3, NE, 0),
    (e2,14, 3, NE, 0),
    (e2, 4, 3, NE, 0),
    (g2, 6, 3, NE, 0),
    (g2, 6, 3, NE, 0),
    (g2, 4, 3, NE, 0),
    (F2, 8, 3, NE, 0),
    (d2, 8, 3, NE, 0),
    (PE, 0, 0, NE, 0));

  DB2 = Pattern:(
    (e2,64, 3, NE, 0),
    (PE, 0, 0, NE, 0));

  Strings1 = Pattern:(
    (c2,16, 5, NE, 0),
    (A1,16, 5, NE, 0),
    (G1,16, 5, NE, 0),
    (A1,16, 5, NE, 0),
    (c2, 7, 5, NE, 0),
    (PS, 1, 0, VO,32),    |Hier taucht ein neuer Effekt auf: Der VO-Effekt.
    (PS, 1, 0, VO,27),    |Damit kann man die Lautstrke einer Note beein-
    (PS, 1, 0, VO,24),    |flussen. Dies kann auch NACH dem Anspielen
    (PS, 1, 0, VO,21),    |der Note geschehen. Hierzu verwendet man einfach
    (PS, 1, 0, VO,18),    |als Notenwert die Pause, und ndert die Laut-
    (PS, 1, 0, VO,16),    |strke. Hier wird z.B. die Lautstrke kontinuier-
    (PS, 1, 0, VO, 8),    |lich vom Standard- (Default-)Wert auf 0 "gefadet".
    (PS, 1, 0, VO, 5),    |brigens: Wird bei einer Note kein VO-Effekt an-
    (PS, 1, 0, VO, 3),    |gegeben, so wird die Default-Lautstrke aus der
    (PS, 1, 0, VO, 2),    |Instrumente-Struktur verwendet (siehe weiter unten).
    (PS, 1, 0, VO, 1),
    (PS, 1, 0, VO, 1),
    (PS,45, 0, VO, 1),    |BEMERKUNG: Es gibt noch einen anderen Pausenbefehl,
    (PE, 0, 0, NE, 0));   |nmlich "PA". Er funktioniert aber anders: Er "wrgt"
                          |die Sound-DMA ab, d.h. schaltet einen Kanal fr
  Drum11P1 = Pattern:(    |eine gewisse Zeitdauer ab. Dann ist keine Lautstrke-
    (e3, 4,10, NE, 0),    |beeinflussung mehr mglich.
    (f3, 1, 8, NE, 0),
    (f3, 1, 8, NE, 0),
    (f3, 1, 8, NE, 0),
    (f3, 1, 8, NE, 0),
    (a2, 4, 2, NE, 0),
    (e3, 2,10, NE, 0),
    (a2, 2, 2, NE, 0),
    (e3, 4,10, NE, 0),
    (f3, 2, 8, NE, 0),
    (f3, 2, 8, NE, 0),
    (a2, 4, 2, NE, 0),
    (a2, 2, 2, NE, 0),
    (a2, 2, 2, NE, 0),
    (e3, 4,10, NE, 0),
    (f3, 1, 8, NE, 0),
    (f3, 1, 8, NE, 0),
    (f3, 1, 8, NE, 0),
    (f3, 1, 8, NE, 0),
    (a2, 4, 2, NE, 0),
    (e3, 2,10, NE, 0),
    (a2, 2, 2, NE, 0),
    (e3, 4,10, NE, 0),
    (f3, 2, 8, NE, 0),
    (f3, 2, 8, NE, 0),
    (a2, 2, 2, NE, 0),
    (a2, 4, 2, NE, 0),
    (a2, 2, 2, NE, 0),
    (PE, 0, 0, NE, 0));


  Drum11P2 = Pattern:(
    (PS, 4, 0, NE, 0),
    (c3, 6, 2, NE, 0),
    (c3, 8, 2, NE, 0),
    (c3, 6, 2, NE, 0),
    (c3,12, 2, NE, 0),
    (c3, 6, 2, NE, 0),
    (c3, 8, 2, NE, 0),
    (a3, 1, 9, NE, 0),
    (a3, 1, 9, NE, 0),
    (a3, 2, 9, NE, 0),
    (g3, 2, 9, NE, 0),
    (g3, 2, 9, NE, 0),
    (f3, 2, 9, NE, 0),
    (e3, 2, 9, NE, 0),
    (d3, 2, 9, NE, 0),
    (PE, 0, 0, NE, 0));

  Bassline2 = Pattern:(
    (c3, 4, 1, NE, 0),
    (c3, 4, 1, NE, 0),
    (D3, 4, 1, NE, 0),
    (c3, 2, 1, NE, 0),
    (f3, 4, 1, NE, 0),
    (f3, 4, 1, NE, 0),
    (D3, 2, 1, NE, 0),
    (f3, 4, 1, NE, 0),
    (g3, 4, 1, NE, 0),
    (c3, 4, 1, NE, 0),
    (c3, 4, 1, NE, 0),
    (D3, 4, 1, NE, 0),
    (c3, 2, 1, NE, 0),
    (f3, 4, 1, NE, 0),
    (f3, 4, 1, NE, 0),
    (D3, 2, 1, NE, 0),
    (f3, 2, 1, NE, 0),
    (D3, 2, 1, NE, 0),
    (d3, 4, 1, NE, 0),
    (PE, 0, 0, NE, 0));

  BassStrings = Pattern:(
    (c1,16, 5, NE, 0),
    (D1,16, 5, NE, 0),
    (A1,16, 5, NE, 0),
    (g1,16, 5, NE, 0),
    (PE, 0, 0, NE, 0));


  Strings2 = Pattern:(
    (c2,12, 5, NE, 0),
    (d2, 4, 5, NE, 0),
    (D2, 6, 5, NE, 0),
    (f2, 6, 5, NE, 0),
    (g2, 4, 5, NE, 0),
    (A2, 2, 5, NE, 0),
    (G2, 4, 5, NE, 0),
    (g2, 2, 5, NE, 0),
    (f2, 8, 5, NE, 0),
    (g2, 2, 5, NE, 0),
    (f2, 4, 5, NE, 0),
    (g2, 2, 5, NE, 0),
    (A2, 2, 5, NE, 0),
    (g2, 2, 5, NE, 0),
    (c3, 2, 5, NE, 0),
    (g2, 2, 5, NE, 0),

    (c2, 8, 5, NE, 0),
    (D2,12, 5, NE, 0),
    (d2, 4, 5, NE, 0),
    (f2, 8, 5, NE, 0),
    (A2, 8, 5, NE, 0),
    (a2, 4, 5, NE, 0),
    (f2, 2, 5, NE, 0),
    (g2, 8, 5, NE, 0),
    (a2, 6, 5, NE, 0),
    (A2, 4, 5, NE, 0),

    (c3, 8, 5, NE, 0),
    (D3,12, 5, NE, 0),
    (d3, 4, 5, NE, 0),
    (f3, 8, 5, NE, 0),
    (A3, 8, 5, NE, 0),
    (a3, 4, 5, NE, 0),
    (f3, 2, 5, NE, 0),
    (g3, 8, 5, NE, 0),
    (D3, 6, 5, NE, 0),
    (d3, 4, 5, NE, 0),
    (PE, 0, 0, NE, 0));

  Strings3 = Pattern:(
    (c3, 2, 5, NE, 0),
    (d3, 2, 5, NE, 0),
    (D3, 2, 5, NE, 0),
    (c3, 2, 5, NE, 0),
    (d3, 2, 5, NE, 0),
    (D3, 4, 5, NE, 0),
    (g3, 4, 5, NE, 0),
    (f3, 4, 5, NE, 0),
    (D3, 2, 5, NE, 0),
    (d3, 4, 5, NE, 0),
    (c3, 4, 5, NE, 0),
    (c3, 2, 5, NE, 0),
    (d3, 2, 5, NE, 0),
    (D3, 2, 5, NE, 0),
    (c3, 2, 5, NE, 0),
    (d3, 2, 5, NE, 0),
    (D3, 4, 5, NE, 0),
    (c3, 4, 5, NE, 0),
    (A2, 4, 5, NE, 0),
    (G2, 2, 5, NE, 0),
    (g2, 4, 5, NE, 0),
    (f2, 4, 5, NE, 0),
    (PE, 0, 0, NE, 0));

  Bells2 = Pattern:(
    (D2, 8, 0, NE, 0),
    (F2,12, 0, NE, 0),
    (f2, 4, 0, NE, 0),
    (G2, 8, 0, NE, 0),
    (C3, 8, 0, NE, 0),
    (c3, 4, 0, NE, 0),
    (G2, 2, 0, NE, 0),
    (A2, 8, 0, NE, 0),
    (c3, 6, 0, NE, 0),
    (C3, 4, 0, NE, 0),
    (PE, 0, 0, NE, 0));

  Bells3 = Pattern:(
    (D3, 8, 0, NE, 0),
    (C3,12, 0, NE, 0),
    (A2, 6, 0, NE, 0),
    (G2, 6, 0, NE, 0),
    (A2, 8, 0, NE, 0),
    (C3, 4, 0, NE, 0),
    (c3,12, 0, NE, 0),
    (G2, 8, 0, NE, 0),
    (PE, 0, 0, NE, 0));

  BellAcc2 = Pattern:(
    (c2,32, 4, NE, 0),
    (D2,16, 4, NE, 0),
    (f2,16, 4, NE, 0),
    (PE, 0, 0, NE, 0));

  Bells4 = Pattern:(
    (G2,16, 0, NE, 0),
    (F2,16, 0, NE, 0),
    (C2,16, 0, NE, 0),
    (D2,16, 0, NE, 0),
    (PE, 0, 0, NE, 0));

  Drum15P1 = Pattern:(
    (e3, 2,10, NE, 0),
    (e3,10,10, NE, 0),
    (e3, 4,10, NE, 0),
    (e3,16,10, NE, 0),
    (e3, 2,10, NE, 0),
    (e3,10,10, NE, 0),
    (e3, 4,10, NE, 0),
    (e3,16,10, NE, 0),
    (PE, 0, 0, NE, 0));

  Drum15P2 = Pattern:(
    (e3, 2,10, NE, 0),
    (e3,10,10, NE, 0),
    (e3, 4,10, NE, 0),
    (e3,16,10, NE, 0),
    (e3, 2,10, NE, 0),
    (e3,10,10, NE, 0),
    (e3, 4,10, NE, 0),
    (e3, 8,10, NE, 0),
    (a2, 4, 2, NE, 0),
    (a2, 2, 2, NE, 0),
    (a2, 2, 2, NE, 0),
    (PE, 0, 0, NE, 0));

   GongDrum = Pattern:(
    (c2,52, 7, NE, 0),
    (e3, 2, 9, NE, 0),
    (e3, 2, 9, NE, 0),
    (d3, 2, 9, NE, 0),
    (d3, 2, 9, NE, 0),
    (c3, 1, 9, NE, 0),
    (c3, 1, 9, NE, 0),
    (c3, 1, 9, NE, 0),
    (c3, 1, 9, NE, 0),
    (PE, 0, 0, NE, 0));


|Das hier ist unbedingt ntig, sonst mten die nachfolgenen Zeilen stets ein
|'PTR wie in der ersten Zeile enthalten! (siehe (*)).
$$RelaxPTR:=TRUE;

|Die Patterns werden nun ber einen Zeiger in ein sog. Patternarray eingetragen,
|um spter in der Arrangementtabelle einfach (ber Offset-Zahlenwerte) auf
|sie zugreifen zu knnen. (Siehe unten).

CONST
               |Name,       |Patternnummer  : Lnge in Zeiteinheiten.
  MyPatterns = Patterns:(
               Pause64'PTR, |0              : 64    |<- (*) 'PTR kann entfallen!
               Bassline1,   |1              : 64
               TomBreak,    |2              : 64
               BasicDrums,  |3              : 64
               BellAcc,     |4              : 64
               Gong,        |5              : 64
               Melody1,     |6              : 5 * 64
               BlastAndGong,|7              : 64
               DieterBohlen,|8              : 64
               DB2,         |9              : 64
               Strings1,    |10             : 2 * 64
               Drum11P1,    |11             : 64
               Drum11P2,    |12             : 64
               Bassline2,   |13             : 64
               BassStrings, |14             : 64
               Strings2,    |15             : 3 * 64
               Strings3,    |16             : 64
               Bells2,      |17             : 64
               Bells3,      |18             : 64
               BellAcc2,    |19             : 64
               Bells4,      |20             : 64
               Drum15P1,    |21             : 64
               Drum15P2,    |22             : 64
               GongDrum);   |23             : 64


|Dies ist nun die Arrangementtabelle. Hier wird fr jeden Kanal die Abspiel-
|reihenfolge der Patterns festgelegt. Wie man sieht, knnen mehrere Patterns
|hintereinander abgespielt werden. Die Lcken in Kanal 3 rhren von der unter-
|schiedlichen Lnge der Patterns her. Nicht alle Kanle mssen benutzt werden
|(siehe "Enabled" gleich untendrunter).
|Noch eine Definition: Statt Kanal sagt man auch zu einer Zeile in der Arrange-
|menttabelle "Track", auf deutsch Spur, wie z.B. bei einem Tonband.
|Die Datenstruktur mu eine Variable sein, da darin verndert werden darf.
|Das TR am Ende eines Tracks bedeutet, da der Track ab der in "Repeat"
|stehenden Position wiederholt werden soll. Ist eine Wiederholung unerwnscht,
|so trgt man TS fr "Track Stop" ein.
VAR

  MySong := Song:(Channels=(
    ArrT:(2,3,3,3,3,3,7,3,3,3,11,11,11,11,11,11,11,11,21,22,23,TR),  |Kanal 0
    ArrT:(1,1,1,1,1,1,1,1,1,1,12,12,14,14,14,14,14, 5,19,19,19,TR),  |  "   1
    ArrT:(0,4,4,4,4,4,4,4,4,  10,13,13,13,13,13,13,13,13,20,20,TR),  |  "   2
    ArrT:(0,5,        6,8,8,8, 9, 5,      15,16,16,17,18,18,18,TR)), |  "   3

    Enabled=(TRUE, TRUE, TRUE, TRUE), |gibt an, welche Kanle/Tracks benutzt wer-
                                      |den. Darf whrend des Abspielens vern-
                                      |dert werden, um gezielt Kanle abzuschal-
                                      |ten (Z.B. um einen einfachen (Simple-)
                                      |Effekt abzuspielen.

    Repeat = (1,1,1,1));              |Hier steht drin, bei welchem Pattern
                                      |fortgefahren werden soll, wenn das
                                      |Ende des Songs/eines Tracks erreicht
                                      |wurde. (Fr jeden Track vorhanden).




|Bentigte Hilfsvariablen:
VAR
  ch : CHAR;
  TempIns : POINTER TO Instrument;
  Loaded : BOOLEAN;



|Und hier beginnt erst unser Programm!
BEGIN
  WriteString("Ich versuche, Samples zu laden.");WriteLn;

|Zunchst werden die Samples eingeladen. Hierzu wird eine Funktion aus dem
|Soundmodul verwendet, sowie die Instrumente-Struktur.
  WITH INTEGER AS i DO
    i:=0;
    Loaded:=TRUE;
    WHILE Loaded AND (i < SampleAnzahl) DO
      WriteString(SampleNamen[i]);WriteLn;
      Loaded:=LoadInstrument(MyInstruments[i],Concat(PfadName,SampleNamen[i]));
       IF Loaded THEN
         WriteString("Konnte Sample ");WriteString(SampleNamen[i]);
         WriteString(" laden!");WriteLn;
         INC(i);
       END;
     END;
  END;

  IF Loaded THEN

|Das Musik-System mu initialisiert werden. Hierzu werden mein Instrumente-
|und Pattern-Array bergeben, damit sie dem System bekannt sind.
    InitSoundSystem(MyInstruments,MyPatterns);

|Hiermit wird mein Lied an den Anfang "gespult".
    GoFirstPos(MySong);

    Read(ch);
    WHILE ch # "x" DO
      IF KEY ch
        OF "p" THEN
          WriteString("Song gestartet...");WriteLn;
          StartSong(MySong,PAL); |Song starten!
                                  |Achtung: Wer nur einen PAL-Amiga hat (50Hz
                                  |Bildwiederholfrequenz), der mu statt NTSC
                                  |hier PAL eintragen!
        END;

        OF "s" THEN
          WriteString("Song gestoppt...");WriteLn;
          StopSong(MySong); |Song anhalten!
        END;

        OF "r" THEN
          WriteString("Song an den Anfang zurckgespult.");WriteLn;
          GoFirstPos(MySong); |An die erste Position des Liedes zurckkehren.
        END;
      END;
      Read(ch);
    END;

|Am Schlu mssen die Instrumente gelscht werden (Chip-Memory freigeben!)
    WITH INTEGER AS i DO
      FOR i:=0 TO SampleAnzahl-1 DO
        KillInstrument(MyInstruments[i]);
      END;
    END;

  ELSE
    WriteString("Mind. ein Sample nicht geladen!");WriteLn;
  END;

  WriteString("Das wars!");WriteLn;

END Prism.
