|##########|
|#MAGIC   #|HAHDPDGI
|#PROJECT #|"SimpleEffectTest"
|#PATHS   #|"StdProject"
|#FLAGS   #|xx---x--xx----x-----------------
|#USERSW  #|--------------------------------
|#USERMASK#|--------------------------------
|#SWITCHES#|xx---xxxxx-xx---
|##########|
MODULE SimpleEffectTest;

FROM Sound IMPORT LoadInstrument,KillInstrument,SimpleEffect,PlaySimpleEffect,
                  KillSimpleEffect,Instrument,Noteval,Instruments,
                  InitSoundSystem,Patterns,Pattern,Noteval,Effects;
FROM InOut IMPORT WriteLn,WriteString,WriteInt,Read;

|*******************************************************************************
|Dies ist ein Beispiel, wie man einen bzw. mehrere einfache (Simple-) Effekte
|auslst. Man beachte: Die verwendeten Ausgabekanle knnen dynamisch zugewiesen
|oder vom Benutzer festgelegt werden.                          S. Herr, 28.09.92
|*******************************************************************************

CONST
  Effect1 = SimpleEffect:(Ch=-1,Val=c3,Ins=0,Vol=64,Use=FALSE);

  PseudoPattern = Pattern:((PE, 0, 0, NE, 0));
  EmptyPatterns = Patterns:(PseudoPattern'PTR);

VAR
  ch : CHAR;

  MyEffect : SimpleEffect;
  MyEffects : ARRAY [0..5] OF SimpleEffect;
  MyInstruments := Instruments:((NIL, 0, 0, 2, 64));
  MyPatterns := NIL;

  i : CARDINAL;

BEGIN
  WriteString("Ich versuche, Sample zu laden.");WriteLn;

  MyEffect := Effect1;
  FOR i:=0 TO 5 DO
    MyEffects[i]:=Effect1;
  END;
   IF LoadInstrument(MyInstruments[0],"Cluster:Samples/ahyeah") THEN
         WriteString("Konnte Sample laden!");WriteLn;

         InitSoundSystem(MyInstruments,EmptyPatterns);

          Read(ch);
          WHILE ch # "x" DO
            IF KEY ch
              OF "p" THEN
                IF PlaySimpleEffect(MyEffect) THEN
                  WriteString("Konnte Effekt spielen. Ch: ");
                  WriteInt(MyEffect.Ch,0);WriteLn;
                ELSE
                  WriteString("Kein Kanal frei oder Effect in use!");WriteLn;
                END;
              END;
              OF "m" THEN
                FOR i:=0 TO 5 DO
                  IF PlaySimpleEffect(MyEffects[i]) THEN
                    WriteString("Konnte Effekt ");WriteInt(i,0);
                    WriteString("spielen. Ch: ");
                    WriteInt(MyEffects[i].Ch,0);WriteLn;
                  ELSE
                    WriteString("Ups? Fehler mit Effekt Nr. ");WriteInt(i,0);
                    WriteLn;
                  END;
                END;
              END;

              OF "r" THEN
                FOR i:=0 TO 5 DO
                  KillSimpleEffect(MyEffects[i]);
                END;
                WriteString("Multiple Effekte gestoppt!");WriteLn;
              END;

              OF "s" THEN
                KillSimpleEffect(MyEffect); WriteString("Effect gestoppt!");
                WriteLn;
              END;
            END;
            Read(ch);
         END;

         KillInstrument(MyInstruments[0]);

    ELSE WriteString("Sample konnte nicht geladen werden!");WriteLn;

  END;

  WriteString("Das wars!");WriteLn;

END SimpleEffectTest.


