|##########|
|#MAGIC   #|BMPDCHAN
|#PROJECT #|"TextListTest"
|#PATHS   #|"StdProject"
|#FLAGS   #|xx---x--x-x---x-----------------
|#USERSW  #|--------------------------------
|#USERMASK#|--------------------------------
|#SWITCHES#|xx---xxxxx-xx---
|##########|
MODULE TextListTest;
FROM InOut        IMPORT WriteGrp,ReadGrp;
FROM Lists        IMPORT TextLists;
FROM Resources    IMPORT New,Dispose;

TYPE
  ChildPtr = POINTER TO Child;

| Es folgt die Ausprgung
DEFINITION MODULE ChildrenLists = TextLists(ChildPtr);

TYPE
  Child    = RECORD OF ChildrenLists.TextNode
               age :  INTEGER;
             END;
VAR
  ChildrenList : ChildrenLists.TextList;
  TempStr      : CLASSPTR TO STRING;
  ActChild     : ChildPtr;
  done         : BOOLEAN:=FALSE;

PROCEDURE WriteChildren(child : ChildPtr);
BEGIN
  WriteString(child.name^);WriteLn;
  WriteInt(child.age);WriteLn;
  IF child.special THEN
    WriteString("Mdchen");
  ELSE
    WriteString("Junge");
  END;
  WriteLn;WriteLn;
END WriteChildren;

PROCEDURE Destruct(child : ChildPtr);
BEGIN
  Dispose(child.name);
  Dispose(child);
END Destruct;

BEGIN
  ChildrenList.Init(ChildrenLists.CmpStringsCaps);
  REPEAT
    TempStr'RANGE:=20;
    New(TempStr);
    WriteString("Namen: ");
    ReadString(TempStr^);
    IF TempStr^.len#0 THEN
      New(ActChild);
      ActChild.name:=TempStr;
      WriteString("Alter: ");
      ReadInt(ActChild.age);
      WriteString("Mdchen ? ");
      ActChild.special:=ReadBool();
      ChildrenList.Insert(ActChild);
    ELSE
      done:=TRUE;
      Dispose(TempStr);
    END
  UNTIL done;
  WriteLn;
  ChildrenList.Apply(WriteChildren);

  | Die nachfolgende Destructanweisung knnte auch entfallen,
  | da das Laufzeitsystem am Programmende allen Speicher wieder
  | freigibt. Wie es geht soll aber trotzdem hier gezeigt werden,
  | angenommen das Programm ginge hier noch weiter.
  | Delete_All htte man nicht verwenden knne, da sonst bis zum
  | Programmende der Speicher der von den Namen belegt ist
  | verloren wre.

  ChildrenList.Destruct_All(Destruct);
END TextListTest.
